use strict;
use warnings;
use bignum;

open my $fi, '<input.txt';
open my $fo, '>output.txt';
my ($h, $v, $x1, $y1, $x2, $y2) = map 0+$_, map {split /\s+/} <$fi>;

sub floor {int(abs($_[0])) * ($_[0] <=> 0)}

sub solve{
  return $x1 % $h ? 1 : -1 if $x1 == $x2;
  return $y1 % $v ? 1 : -1 if $y1 == $y2;
  ($x1, $y1, $x2, $y2) = ($x2, $y2, $x1, $y1) if $x1 > $x2;
  return 1 if $y1 > $y2;
  return abs(($y1*($x2-$x1)/($y1-$y2)+$x1)/$h-0.5) > 0.5 ? 0 : -1 if $v/$h == ($y2-$y1)/($x2-$x1);
  my $h1 = ($x1*($y2-$y1)-$y1*($x2-$x1)) / ($h*($y2-$y1)-$v*($x2-$x1));
  my $h2 = (($x1-$h)*($y2-$y1)-$y1*($x2-$x1)) / ($h*($y2-$y1)-$v*($x2-$x1));
  my $hor = abs(floor($h1)-floor($h2));
  my $v1 = ($x1*($y2-$y1)-$y1*($x2-$x1)) / ($h*($y2-$y1)-$v*($x2-$x1));
  my $v2 = ($x1*($y2-$y1)-($y1+$v)*($x2-$x1)) / ($h*($y2-$y1)-$v*($x2-$x1));
  my $ver = abs(floor($v1)-floor($v2));
  my $ans = $ver + $hor + int($h1 == floor($h1) && $h2 != floor($h2) || $h1 != floor($h1) && $h2 == floor($h2) ||
    $v1 == floor($v1) && $v2 != floor($v2) || $v1 != floor($v1) && $v2 == floor($v2));
}

print $fo solve(), "\n";
close $fi;
close $fo;