{$APPTYPE CONSOLE}
var
  f: TextFile;
  h, v, x1, y1, x2, y2, dx, dy: Int64;

  function Cross(xa, ya, xb, yb: Int64): Boolean;
  var
    s1, s2: Int64;
  begin
    s1 := (xa - x1) * dy - (ya - y1) * dx;
    s2 := (xb - x1) * dy - (yb - y1) * dx;
    if (s1 = 0) or (s2 = 0) then Result := xa <> xb
    else Result := (s1 > 0) xor (s2 > 0);
  end;

  function Solve: Int64;
  var
    x, y, px, py: Int64;
    i, r: Integer;

    function Check: BooleAN;
    begin
      Result := true;
      if (x < -100000000000) or (y < -100000000000) then exit;
      if Cross(x, y, px, py) then begin
        //Writeln(x, ' ', y, ' ', px, ' ', py);
        Inc(r);
      end
      else if (r > 0) and (x <> px) then exit;
      px := x; py := y;
      Result := false;
    end;

  begin
    if x1 = x2 then begin
      if x1 mod h = 0 then Result := -1 else Result := 1;
      exit;
    end;
    if y1 = y2 then begin
      if y1 mod v = 0 then Result := -1 else Result := 1;
      exit;
    end;
    dx := x2 - x1; dy := y2 - y1;
    Result := 0;
    if dx * v = h * dy then begin
      if Cross(0, 0, h, 0) then
        Result := -1;
      exit;
    end;
    px := 0; py := 0; x:= 0; y := 0; r := 0;
    for i := 0 to 20000000 do begin
      if i mod 2 = 0 then x := px + h else y := py + v;
      if Check then break;
    end;
    Inc(Result, r);
    px := 0; py := 0; x:= 0; y := 0; r := 0;
    for i := 0 to 1000000 do begin
      if i mod 2 = 0 then y := py - v else x := px - h;
      if Check then break;
    end;
    Inc(Result, r);
  end;

begin
  AssignFile(f, 'input.txt'); Reset(f);
  Read(f, h, v, x1, y1, x2, y2);
  CloseFile(f);
  AssignFile(f, 'output.txt'); Rewrite(f);
  Writeln(f, Solve);
  CloseFile(f);
end.